@rem = '--*-Perl-*--
@echo off
if not "%1"=="" goto continue
echo.
echo GAMS-X Book Script
echo ------------------
echo.
echo Creates a casebook for a user's model account, puts a set of cases in
echo the casebook and creates the graphs for that casebook.
echo.
echo Syntax:  book Book Model User Case1 [Case2 . . .]
echo.
echo where Book is a casebook name, User is a user name, Model is a model
echo name, and Case? is an existing case to be put in the casebook.
echo.
echo Example:
echo.
echo book NewCasebook Ramsey Grog NewCase
echo.
echo creates the casebook STUDY1 for the user Grog in the model Ramsey and  
echo puts the cases HIGHB and HIGHG in it.
echo.
echo As with all GAMS-X scripts, it is strongly recommended that you exit
echo GAMS-Tk before using this utility.  See also case.bat.
echo.
goto endofperl
:continue
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!perl
#line 14

use GAMS::Tools;

$GAMS = new GAMS::Tools;

$Book = shift @ARGV;
$Model = shift @ARGV;
$User = shift @ARGV;

#       Generate the Initial Cases

print "Creating the casebook $Book . . .\n";

$GAMS->Set(
     -Model => "$Model",
     -User => "$User",
);


$GAMS->Set(
     -Casebook => "$Book",
);
$GAMS->NewCasebook;

for (@ARGV) {

        print "Putting case '$_' in casebook '$Book' . . .\n";

        $GAMS->Set(
                -Case => $_
        );
        $GAMS->Book;

}

$GAMS->CasebookPlot;

$GAMS->Quit;

__END__
:endofperl
