$if not setglobal debug $offlisting offinclude
$ontext

            SSIMPORT: A Spreadsheet Data Import Utility for GAMS

                     (an interface to SSLINK.EXE)

Usage:

               $LIBINCLUDE SSIMPORT parameter ssfile range

              N.B.      Data import occurs at compile time.
                        Parameter must be declared with explicit dimension.

$offtext

$if setglobal ss_system $goto countargs
$setglobal ss_system 'operating'
$echo %system.gstring%     >sslink.log
$echo SSLINK Activity Log >>sslink.log
$label countargs

$setlocal param  '%1'
$setlocal ssfile '%2'
$setlocal range  '%3'


$if not a%range% == a  $goto checkfile
$error SSIMPORT arguments missing ssfile=%ssfile% range=%range% param=%param%
$log *** SSIMPORT incorrect call
$exit

$label checkfile
$if exist %ssfile%  $goto checkparam
$error SSIMPORT spreadsheet file (%ssfile%) is missing.
$log *** SSIMPORT spreadsheet file (%ssfile%) is missing.
$exit

$label checkparam
$if declared %param% $goto start
$error SSIMPORT parameter %param% has not been declared prior to call.
$log *** SSIMPORT parameter %param% has not been declared prior to call.
$exit

$label start

$log --- Importing "%param%" from spreadsheet "%ssfile%" range "%range%"

$set newfile '%gams.scrdir%gamslink.scr'
$if not setglobal oldfile $setglobal oldfile ''
$if '%oldfile%' == '%newfile%' $goto fileok
$setglobal oldfile %newfile%
$if declared sslink_tmp $kill sslink_tmp
file sslink_tmp / %newfile% /;
$label fileok

$if dimension 0  %param% $set r '0'
$if dimension 1  %param% $set r '1'
$if dimension 2  %param% $set r '2'
$if dimension 3  %param% $set r '3'
$if dimension 4  %param% $set r '4'
$if dimension 5  %param% $set r '5'
$if dimension 6  %param% $set r '6'
$if dimension 7  %param% $set r '7'
$if dimension 8  %param% $set r '8'
$if dimension 9  %param% $set r '9'
$if dimension 10 %param% $set r '10'

$echo %system.incparent% SSIMPORT %1 %2 %3 %4 >>sslink.log
$call '=%gams.sdir%sslink %ssfile% %range% %param% %r% >%newfile%'
$onlisting
$if     dimension 0 %param% scalar %param% /
$if not dimension 0 %param% parameter %param% /
$include %newfile%
/;
