$if not setglobal debug $offlisting offinclude

$version 86

$hidden   ZIP2GAMS: Data import from ZIP archive 

$hidden   Requires compatible UNZIP in the GAMS directory or on the PATH.
   
$hidden   Requires operating-system definitions for libinclude file delete.gms

$hidden   ZIP and UNZIP are found at http://www.cdrom.com/pub/infozip/Info-Zip.html

$hidden   Syntax:

$hidden   $...include zip2gams archive [item1 [-n name] [item2 ...]

*       Details:

*               When an archive is specified but no items are mentioned, the archive is input 
*               as a unit (all items are read).

*       -n      Indicates the archive name from which the item is to be read.  
*               Default assumption is that the archive name and the item name are the same.

$hidden   Created 1/98 (tfr)

*       Skip compilation is there is a pre-existing program error:

$if not errorfree $exit

$if declared u___1 $goto declared

*       Declare temporary variables used for data transfer.


alias(u___1,u___2,u___3,u___4, u___5,u___6,u___7,u___8,u___9,u___10,*);

$if errorfree $goto declared
$onlisting

*       An error has occured invocation of zip2gams. 

*       There are two reasons that an error may have been generated here:

*       (i) The program has invoked zip2gams inside an if block or loop.  
*       This is not permitted.

*       (ii) The user program has used one of the gams2txt reserved names, 
*       u___n for n = 0,1,2,...,10.

$abort 'Error on initial $libinclude zip2gams.'

$label declared

*       Blank invocation -- nothing to do:

$if "%1" == "" $exit

*       Archive name is given first:

$set archive %1

$if not "%2"=="" $goto start

*       Unpack a complete archive:

$if setglobal debug $log  'unzip -oqC %archive% UNPACK.SCR -d"%gams.scrdir%'
$call '%gams.sdir%unzip -oqC %archive% UNPACK.SCR -d"%gams.scrdir%'
$batinclude "%gams.scrdir%UNPACK.SCR" %archive%
$EXIT

$label start

$shift
$if "%1" == "" $exit

$set item %1
$set name %1

$if "%2"=="-n" $goto setname
$if "%2"=="-N" $goto setname
$goto unzip

$label setname

$if not "%3"=="" $goto nameok

$log "Invalid syntax for zip2gams item %item%."
$log "-N must be followed by new name."
$abort "Syntax error in call zip2gams for arguments %args%"

$label nameok
$set name "%3" 
$shift 
$shift

$label unzip

$if setglobal debug $log  'unzip -oqC %archive% %name% -d"%gams.scrdir%'
$call '%gams.sdir%unzip -oqC %archive% %name% -d"%gams.scrdir%'

$if exist "%gams.scrdir%%name%" $goto input

$log   Error retrieving %name% from ZIP archive %archive%

$call "%gams.sdir%unzip -l %archive%"
$abort Error retrieving %name% from ZIP archive %archive%

$label input

$if vartype %item% $goto varequ
$if equtype %item% $goto varequ
$goto parameter

*       Set up temporary sets for data transfer of a level
*       value or marginal (these cannot be read in directly
*       as a parameter):

$label varequ

$set zipdata none

$if not declared zip2gams49 $set zipdata 49
$if not declared zip2gams48 $set zipdata 48
$if not declared zip2gams47 $set zipdata 47
$if not declared zip2gams46 $set zipdata 46
$if not declared zip2gams45 $set zipdata 45
$if not declared zip2gams44 $set zipdata 44
$if not declared zip2gams43 $set zipdata 43
$if not declared zip2gams42 $set zipdata 42
$if not declared zip2gams41 $set zipdata 41
$if not declared zip2gams40 $set zipdata 40

$if not declared zip2gams39 $set zipdata 39
$if not declared zip2gams38 $set zipdata 38
$if not declared zip2gams37 $set zipdata 37
$if not declared zip2gams36 $set zipdata 36
$if not declared zip2gams35 $set zipdata 35
$if not declared zip2gams34 $set zipdata 34
$if not declared zip2gams33 $set zipdata 33
$if not declared zip2gams32 $set zipdata 32
$if not declared zip2gams31 $set zipdata 31
$if not declared zip2gams30 $set zipdata 30

$if not declared zip2gams29 $set zipdata 29
$if not declared zip2gams28 $set zipdata 28
$if not declared zip2gams27 $set zipdata 27
$if not declared zip2gams26 $set zipdata 26
$if not declared zip2gams25 $set zipdata 25
$if not declared zip2gams24 $set zipdata 24
$if not declared zip2gams23 $set zipdata 23
$if not declared zip2gams22 $set zipdata 22
$if not declared zip2gams21 $set zipdata 21
$if not declared zip2gams20 $set zipdata 20

$if not declared zip2gams19 $set zipdata 19
$if not declared zip2gams18 $set zipdata 18
$if not declared zip2gams17 $set zipdata 17
$if not declared zip2gams16 $set zipdata 16
$if not declared zip2gams15 $set zipdata 15
$if not declared zip2gams14 $set zipdata 14
$if not declared zip2gams13 $set zipdata 13
$if not declared zip2gams12 $set zipdata 12
$if not declared zip2gams11 $set zipdata 11
$if not declared zip2gams10 $set zipdata 10

$if not declared zip2gams09 $set zipdata 09
$if not declared zip2gams08 $set zipdata 08
$if not declared zip2gams07 $set zipdata 07
$if not declared zip2gams06 $set zipdata 06
$if not declared zip2gams05 $set zipdata 05
$if not declared zip2gams04 $set zipdata 04
$if not declared zip2gams03 $set zipdata 03
$if not declared zip2gams02 $set zipdata 02
$if not declared zip2gams01 $set zipdata 01
$if not declared zip2gams00 $set zipdata 00

$if %zipdata%==none $abort "Too many arrays in archive -- the limit is currently 50"

$if dimension 0 %item% $goto scalar 
$if dimension 1 %item% $set r 'u___1' set domain "*"
$if dimension 2 %item% $set r 'u___1,u___2' set domain "*,*"
$if dimension 3 %item% $set r 'u___1,u___2,u___3' set domain "*,*,*"
$if dimension 4 %item% $set r 'u___1,u___2,u___3,u___4' set domain "*,*,*,*"
$if dimension 5 %item% $set r 'u___1,u___2,u___3,u___4,u___5' set domain "*,*,*,*,*"
$if dimension 6 %item% $set r 'u___1,u___2,u___3,u___4,u___5,u___6' set domain "*,*,*,*,*,*"
$if dimension 7 %item% $set r 'u___1,u___2,u___3,u___4,u___5,u___6,u___7' set domain "*,*,*,*,*,*,*"
$if dimension 8 %item% $set r 'u___1,u___2,u___3,u___4,u___5,u___6,u___7,u___8' set domain "*,*,*,*,*,*,*,*"
$if dimension 9 %item% $set r 'u___1,u___2,u___3,u___4,u___5,u___6,u___7,u___8,u___9' set domain "*,*,*,*,*,*,*,*,*"
$if dimension 10 %item% $set r 'u___1,u___2,u___3,u___4,u___5,u___6,u___7,u___8,u___9,u___10' set domain "*,*,*,*,*,*,*,*,*,*"

*--------------------------------------------------

$onempty
parameter zip2gams%zipdata%(%domain%) /
$include %gams.scrdir%%name%
 /;

$onuni
%item%(%r%) = zip2gams%zipdata%(%r%);
$offuni

$libinclude delete "%gams.scrdir%%name%" call
$goto start

*--------------------------------------------------
$label scalar
scalar zip2gams%zipdata% /
$include %gams.scrdir%%name%
 /;
%item% = zip2gams%zipdata%;
$libinclude delete "%gams.scrdir%%name%" call
$goto start

*--------------------------------------------------
$label parameter

$if dimension 0 %item% $goto scalarparm

$onempty
parameter %item% /
$include %gams.scrdir%%name%
/;
$libinclude delete "%gams.scrdir%%name%" call
$goto start

$label scalarparm
scalar %item% /
$include %gams.scrdir%%name%
/;
$libinclude delete "%gams.scrdir%%name%" call
$goto start
